C******************************************************************
C     **** DAXPY ... (dense)Y = ALPHA * (dense)X + (dense)Y ****
C******************************************************************
C
      SUBROUTINE DAXPY(X,Y,K,ALPHA)
C
C *** PARAMETERS
      INTEGER*4 K
      DOUBLE PRECISION X(*),Y(*),ALPHA
C
C *** LOCAL VARIABLES
      INTEGER*4 I
C
C *** PURPOSE
C     This routine computes the following sum:
C     (dense)Y = ALPHA * (dense)X + (dense)Y
C
C *** HISTORY:
C     Written by:    Jacek Gondzio, Systems Research Institute,
C                    Polish Academy of Sciences, Newelska 6,
C                    01-447 Warsaw, Poland.
C     Last modified: March 24, 1992
C
C *** BODY OF (DAXPY) ***
C
      DO 100 I=1,K
         Y(I)=Y(I)+ALPHA*X(I)
  100 CONTINUE
      RETURN
C
C *** LAST CARD OF (DAXPY) ***
      END
