C**************************************************
C     ***   MYTIME ... PRINT THE ELAPSED TIME   ***
C**************************************************
C
C     NOTE:  Choose a variant of TIME routine appropriate for 
C     your system. Do it by commenting out unused parts of the 
C     code. Eventually, add your own TIME routine.
C
C
      SUBROUTINE MYTIME(JOB,IOLOG)
C
C *** PARAMETERS
      INTEGER*4 JOB,IOLOG
      CHARACTER*100 BUFFER
C
C
C     For DOS, the integer array IDATIM is used by subroutine TIMEPF
C     to store the current date, time and elapsed time.
C
C     For (SUN) UNIX, the real scalar ELTIME is used by subroutine 
C     DATTIM to store the elapsed time.
C
C     For (IBM) UNIX, the real scalars T1,T2 are used by subroutine 
C     SECONDS to store the elapsed time.
C
C
C     Only for DOS
      COMMON/IDTM/ IDATIM
      INTEGER*4    IDATIM(9)
C
C     Only for SUN UNIX
      COMMON /TIME/ ELTIME
      REAL ELTIME(3)
C
C     Only for IBM UNIX 
      COMMON /TIMIBM/ T1,T2
      DOUBLE PRECISION T1,T2
      DOUBLE PRECISION SECONDS
C
C
C *** PARAMETERS DESCRIPTION
C     JOB     is an integer input variable:
C             0  initialize the clock;
C             1  print the elapsed time.
C     IOLOG   non-negative output file number.
C
C
C
C
C *** HISTORY:
C     Written by:    Jacek Gondzio, Systems Research Institute,
C                    Polish Academy of Sciences, Newelska 6,
C                    01-447 Warsaw, Poland.
C     Last modified: May 13, 1995
C
C
C
C
C *** BODY OF (MYTIME) ***
C
C
C
C     Here for DOS
C     ------------
C     CALL TIMEPF(JOB,IOLOG,IDATIM)
C
C
C
C     Here for UNIX (SUN SPARC workstation)
C     -------------------------------------
C     CALL DATTIM(JOB,IOLOG,ELTIME)
C
C
C
C     Here for UNIX (IBM RISC6000 and Power PC workstations)
C     ------------------------------------------------------
      IF(JOB.EQ.0) THEN 
         call init_seconds()
         T1 = seconds()
         T2 = T1
      ELSE
         T2 = seconds()
      ENDIF
      WRITE(BUFFER,101) (T2 - T1)
  101 format(1X,'MYTIME: Elapsed user time:',F12.2)
      CALL MYWRT(IOLOG,BUFFER)
C
C
C
      RETURN
C
C *** LAST CARD OF (MYTIME) ***
      END
