C*************************************************************
C     ****  PREPRO ... PREPROCESSING THE  LP PROBMEM  ****
C*************************************************************
C
      SUBROUTINE PREPRO(MAXM,MAXN,MAXNZA,MAXNZL,M,N,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
     X INTMP1,IMTMP1,IMTMP2,RMTMP1,
     X DHEAD,PERM0,INVP0,NBRHD,QSIZE,QLINK,
     X PERM,INVP,HEADER,LINKFD,LINKBK,
     X LCLPTS,LRWNBS,LLINKS,
     X STAVAR,VUSED,VBNDED,P,Q,RWNAME,STAROW,RWSTAT,RANGES,
     X NZL,ICALL,IOLOG)
C
C
C *** PARAMETERS
      INTEGER*4 MAXM,MAXN,MAXNZA,MAXNZL,M,N,LIWORK,LRWORK
      INTEGER*4 NZL,ICALL,IOLOG
      INTEGER*4 INTMP1(MAXN),IROW(MAXN)
      DOUBLE PRECISION RMTMP1(MAXM),RELT(MAXN)
      INTEGER*4 IMTMP1(MAXM+1),IMTMP2(MAXM+1)
      INTEGER*4 DHEAD(MAXM),PERM0(MAXM),INVP0(MAXM)
      INTEGER*4 NBRHD(MAXM),QSIZE(MAXM),QLINK(MAXM)
      INTEGER*2 PERM(MAXM),INVP(MAXM)
      INTEGER*2 HEADER(MAXM+1),LINKFD(MAXM+1),LINKBK(MAXM+1)
      CHARACTER*8 RWNAME(MAXM)
      DOUBLE PRECISION P(MAXM),Q(MAXM),RANGES(MAXM)
      INTEGER*2 STAVAR(MAXN),STAROW(MAXM),RWSTAT(MAXM)
      LOGICAL VUSED(MAXN),VBNDED(MAXN)
C
C *** DATA STRUCTURES FOR CHOLESKY FACTOR
C     DOUBLE PRECISION LCOEFF(MAXNZL)
C     DOUBLE PRECISION LDIAG(MAXM)
      INTEGER*4 LCLPTS(MAXM+1),LLINKS(MAXNZL)
      INTEGER*2 LRWNBS(MAXNZL)
C
C *** HIDDEN DATA STRUCTURES
      INTEGER*4 IWORK(LIWORK),IMAP(*),RMAP(*)
      DOUBLE PRECISION RWORK(LRWORK)
C
C
C
C *** LOCAL VARIABLES
      INTEGER*4 I,IMDO,J,K,NZAAT,TRIANG
      CHARACTER*100 BUFFER
C
C *** VARIABLES FOR MMD ROUTINE
      INTEGER*4 IDELTA,MAXINT,NOFSUB
C
C
C *** COMMON ARREAS
C     Cholesky factorization parameters.
      SAVE   /CHFCT/
      COMMON /CHFCT/   CSMALL,PIVTOL,TAU,DENSE,PIVMAX,PIVMIN,IDNSRW
      DOUBLE PRECISION CSMALL,PIVTOL,TAU,DENSE,PIVMAX,PIVMIN
      INTEGER*4        IDNSRW
C
C     Additional Cholesky fact. parameters (interface to HYBRID).
      COMMON /CHHYB/   RO,FLOPS,IREG,NZCHL,RTCD
      DOUBLE PRECISION RO,FLOPS
      INTEGER*4        IREG,NZCHL,RTCD
C
C     Markers for linking rows.
      SAVE   /ICGRAD/
      COMMON /ICGRAD/ MSPLIT(100000)
      INTEGER*2       MSPLIT
C
C
C
C *** PARAMETERS DESCRIPTION
C
C     ON INPUT:
C     MAXM    Maximum row dimension of the LP constraint matrix.
C     MAXN    Maximum column dimension of the LP constraint matrix.
C     MAXNZA  Maximum number of nonzeros of the LP constraint matrix.
C     MAXNZL  Maximum number of nonzeros of the Cholesky factor.
C     M       Number of rows of the LP constraint matrix
C             (and the dimension of  A*Atransp).
C     N       Number of columns of the LP constraint matrix.
C     INTMP1  Integer work array of size MAXN.
C     IMTMP1  Integer work array of size MAXM.
C     IMTMP2  Integer work array of size MAXM.
C     IROW and  RELT are the arrays for temporary handling of rows
C             and columns of the constraint matrix. They are primarily
C             intended to handle sparse vectors (in packed form)
C             but may also be used for storing dense ones.
C             dense ones.
C     RMTMP1  Double precision work array of size MAXM.
C     PERM    Permutation resulting from the minimum degree ordering.
C     INVP    Inverse permutation.
C     HEADER  Header of the doubly linked lists.
C     LINKFD  Forward linked lists.
C     LINKBK  Backward linked lists.
C     LCLPTS  Pointers to columns of the Cholesky factor.
C     LRWNBS  Row numbers of nonzeros in columns of matrix  L.
C     LLINKS  Linked lists for Cholesky factor.
C     STAVAR  Array of variable status:
C             0  STANDARD (nonnegative) variable i.e.: 0 <= x <= +inf;
C             1  UPPER bounded variable i.e.: 0 <= x <= u;
C             2  LOWER bounded variable i.e.: l <= x <= +inf;
C             3  both LOWER and UPPER bounded variable i.e.: l <= x <= u;
C             4  MINUS INFINITY type variable i.e.: -inf <= x <= u;
C             5  PLUS INFINITY type variable i.e.: l <= x <= +inf;
C             6  FIXED variable i.e.: x = l = u;
C            -k  FREE variable. As the free variable is split into two
C                variables,  k is the number of its brother. Observe,
C                that k-th variable will also have negative status
C                that indicates the position of the original variable.
C     RWNAME  Array of row names (increasing order sort).
C     STAROW  Array of row status:
C             0  row has been removed (it indicates a free row);
C             1  row has not been removed.
C     RWSTAT  Array of row types (sort as before):
C             1  row type is = ;
C             2  row type is >= ;
C             3  row type is <= ;
C             4  row type is objective or free.
C     P       LOWER bounds on shadow prices (dual variables).
C     Q       UPPER bounds on shadow prices (dual variables).
C     RANGES  Array of constraint ranges.
C     ICALL   Number of call of this routine:
C             0 means that sufficient storage is allocated
C               to complete preprocessing phase;
C             1 means that number of nonzeros in adjacency
C               structure  A*Atransp is only to be computed;
C             2 means that adjacency structure of  A*Atransp
C               is to be determined and minimum degree ordering
C               is to be found;
C             3 means that symbolic factorization is to be done.
C     IOLOG   Output unit number where log messages are to be written.
C
C     ON OUTPUT:
C     VUSED   An indicator if a variable is active in the optimization
C             process:
C             .TRUE.   active variable;
C             .FALSE.  FIXED variable.
C     VBNDED  An indicator if a variable has an UPPER bound:
C             .TRUE.   UPPER bounded variable;
C             .FALSE.  UNBOUNDED variable;
C
C     NZL     Number of nonzeros of the Cholesky factor.
C     Data structures for Cholesky matrix:
C     LCLPTS  Pointers to columns of the Cholesky factor.
C     LRWNBS  Row numbers of nonzeros in columns of matrix  L.
C
C
C
C
C *** HIDDEN DATA STRUCTURES DESCRIPTION
C     RWORK   Real work array containing almost all real
C             LP problem data.
C     IWORK   Integer work array containing almost all integer
C             LP problem data.
C     RMAP    Map of RWORK.
C     IMAP    Map of IWORK.
C
C     Map of IWORK array:
C     IMAP(1)   Points to CLPNTS array.
C     IMAP(2)   Points to RWNMBS array.
C     IMAP(3)   Points to RWHEAD array.
C     IMAP(4)   Points to RWLINK array.
C     IMAP(5)   Points to CLNMBS array.
C     IMAP(6)   Points to LENCOL array.
C     IMAP(7)   Points to the first empty cell of IWORK array.
C
C     Map of RWORK array:
C     RMAP(1)   Points to ACOEFF array.
C     RMAP(2)   Points to C array.
C     RMAP(3)   Points to RHS array.
C     RMAP(4)   Points to the first empty cell of RWORK array.
C
C
C
C
C *** SUBROUTINES CALLED:
C     MYWRT,MYSTOP,CNTAAT,DEFAAT,MDO,
C     REORDA,REORDI,REORDV,SYMFCT,DTSRTA
C
C
C *** PURPOSE:
C     This routine preprocesses the linear programming problem.
C     It does the following steps: 
C     (i)     building and analysis of the sparsity pattern
C             of  A*Atransp (a minimum degree heuristic is used
C             to find a row permutation of  A that leads to the
C             sparsest possible Cholesky factor of  A*Atransp);
C     (ii)    permutation of rows of  A according to the reordering
C             resulting from the mininmum degree heuristic;
C     (iii)   setting up data structures for sparse Cholesky
C             decomposition (symbolic factorization);
C     (iv)    permutation of nonzero elements in each column of A
C             to ensure their increasing order. 
C
C
C *** NOTES:
C
C
C *** REFERENCES:
C     Altman A., Gondzio J. (1993). An efficient implementation of
C        a higher order primal-dual interior point method for large
C        sparse linear programs, Archives of Control Sciences 2,
C        No 1-2, pp. 23-40.
C     Altman A., Gondzio J. (1993). HOPDM - A higher order primal-
C        dual method for large scale linear programmming, European
C        Journal of Operational Research 66 (1993) pp 158-160.
C     Duff I.S., Erisman A.M., Reid J.K. (1989). Direct methods
C        for sparse matrices, Clarendon Press, Oxford 1989.
C     Gondzio J. (1992). Splitting dense columns of the constraint
C        matrix in interior point methods for large scale linear
C        programming, Optimization 24, pp. 285-297.
C     Gondzio J. (1993). Implementing Cholesky factorization
C        for interior point methods of linear programming,
C        Optimization 27, pp. 121-140.
C     Gondzio J. (1994). Presolve analysis of linear programs prior
C        to applying an interior point method, Technical Report
C        No 1994.3, Department of Management Studies, University
C        of Geneva, 102, Bd. Carl-Vogt, 1211 Geneva, Switzerland,
C        February 1994, revised in December 1994.
C     Gondzio J. (1994). Multiple centrality corrections in a primal-
C        dual method for linear programming, Technical Report
C        No 1994.20, Department of Management Studies, University
C        of Geneva, 102, Bd. Carl-Vogt, 1211 Geneva, Switzerland,
C        November 1994, revised in May 1995.
C     Gondzio J., Makowski M. (1995). Solving a class of LP problems
C        with a primal-dual logarithmic barrier method, European
C        Journal of Operational Research 80, pp. 184-192.
C     Gondzio J., Tachat D. (1994). The design and application of
C        IPMLO - a FORTRAN library for linear optimization with
C        interior point methods, RAIRO Recherche Operationnelle 28,
C        No 1, pp. 37-56.
C
C
C *** HISTORY:
C     Written by:    Jacek Gondzio, Systems Research Institute,
C                    Polish Academy of Sciences, Newelska 6,
C                    01-447 Warsaw, Poland.
C     Date written:  May 11, 1991
C     Last modified: June 9, 1995
C
C
C
C *** BODY OF (PREPRO) ***
C
C     Set tolerances used by the Cholesky decomposition.
      CSMALL=2.3D-16
      TAU=2.3D-16
      DENSE=0.999D0
C
C
      IF(ICALL.EQ.2) GO TO 200
      IF(ICALL.EQ.3) GO TO 400
C
C
C     Define VUSED and VBNDED logical arrays.
      DO 100 J=1,N
         K=STAVAR(J)
         VUSED(J)=.TRUE.
         VBNDED(J)=.FALSE.
         IF(K.EQ.1.OR.K.EQ.3) VBNDED(J)=.TRUE.
         IF(K.GE.6) VUSED(J)=.FALSE.
  100 CONTINUE
C
C
C     Reorder rows of the  LP constraint matrix to minimize
C     the fill-in of the Cholesky factor.
C
C     Determine how much space is needed for A*Atransp.
C
      TRIANG=0
      CALL CNTAAT(M,MAXM,MAXN,MAXNZA,NZL,
     X TRIANG,LCLPTS,IMTMP1,IMTMP2,STAVAR,
     X IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(3)),
     X IWORK(IMAP(4)),IWORK(IMAP(5)),IWORK(IMAP(6)),IOLOG)
C
      NZL=2*NZL
      NZAAT=NZL
      IF(ICALL.EQ.1) GO TO 1000
C
C     Check if there is enough room for adjacency structure.
      IF(NZL.GT.MAXNZL) GO TO 9000
C
C
C
C     Determine the sparsity structure of A*Atransp.
C
  200 TRIANG=0
      CALL DEFAAT(LRWNBS,LCLPTS,LLINKS,
     X MAXNZL,MAXM,MAXN,MAXNZA,M,TRIANG,
     X IMTMP1,IMTMP2,STAVAR,
     X IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(3)),
     X IWORK(IMAP(4)),IWORK(IMAP(5)),IWORK(IMAP(6)),IOLOG)
      NZL=LCLPTS(M+1)-1
C
C
C     Perform the mininmum degree heuristic.
C     Print the current date, time and elapsed time.
      WRITE(BUFFER,201)
  201 FORMAT(1X,'PREPRO: Minimum degree ordering starts.')
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
C
C     CALL MYTIME(1,IOLOG)
C     CALL MYTIME(1,0)
C
C     Use very cheap ordering.
C     CALL CHEAP(LRWNBS,LCLPTS,LLINKS,MAXNZL,MAXM,M,NZL,
C    X PERM,INVP,HEADER,LINKFD,LINKBK,
C    X INTMP1,IMTMP1,IMTMP2,IROW,IOLOG)
C
C     Decide which ordering will be used.
      IMDO=0
      DO 210 I=1,M
         IF(MSPLIT(I).EQ.1) IMDO=1
  210 CONTINUE
      IF(IMDO.EQ.1) THEN
C
C     Use the minimum degree ordering.
         CALL MDO(LRWNBS,LCLPTS,LLINKS,MAXNZL,MAXM,M,NZL,
     X    PERM,INVP,HEADER,LINKFD,LINKBK,
     X    INTMP1,IMTMP1,IMTMP2,IROW,IOLOG)
C
      ELSE
C
C     Use the multiple minimum degree ordering.
         IDELTA=10
         MAXINT=100000000
         NOFSUB=100000000
         DO 220 I=1,LCLPTS(M+1)-1
            LLINKS(I)=LRWNBS(I)
C           WRITE(BUFFER,221) I,LLINKS(I)
C 221       FORMAT(1X,'PREPRO:  row=',I6,'  llinks=',I6)
C           CALL MYWRT(IOLOG,BUFFER)
  220    CONTINUE
C
C     To avoid crash in MMD (when delay of degree updates is used), 
C     the following elements of DHEAD array have to be nonpositive.
         DO 230 I=M+1,M+IDELTA
            DHEAD(I)=0
  230    CONTINUE
C
C        MMD routine is Joseph Liu's implementation of the Multiple 
C        Minimum Degree ordering. See: "The evolution of the minimum
C        degree ordering algorithm", SIAM Review 33 (89), 1, pp. 1-19.
C        NOTE: This routine can be used EXCLUSIVELY for research
C        purposes.
         CALL MMD(M,LCLPTS,LLINKS,INVP0,PERM0,IDELTA,
     X    DHEAD,QSIZE,IMTMP1,IMTMP2,MAXINT,NOFSUB)
C
C        GENQMD routine is an implementation of the Quotient tree 
C        Minimum Degree ordering available from SPARSPAK (via Netlib). 
C        This routine is based on the book "Computer Solution of Large 
C        Sparse Positive Definite Systems" by George and Liu, Prentice 
C        Hall 1981.
C        CALL GENQMD(M,LCLPTS,LLINKS,PERM0,INVP0,DHEAD,
C    X    IMTMP1,IMTMP2,NBRHD,QSIZE,QLINK,NOFSUB)
C
         DO 240 I=1,M
            INVP(I)=INVP0(I)
            PERM(I)=PERM0(I)
  240    CONTINUE
C
C        Unfortunately, if you use MMD or GENQMD routine, then you 
C        have no estimate of the number of nonzeros required to store 
C        matrix L (after MDO, this estimate is known: NZL). There is 
C        no concern of it if you call this PREPRO with ICALL=0 (a 
C        usual application of pure FORTRAN HOPDM).
C        However, in multiple entries to this routine (when it is
C        called, for example, from C/C++), one needs a reasonable 
C        estimate for NZL to reallocate space for Cholesky matrix.
C        We use here NZL = 2 * the number of nonzeros in AAt and
C        we try to run SYMFCT. If SYMFCT fails, it will give a better 
C        estimate of space needed for matrix L.
C        NZL=LCLPTS(M+1)-1 and will be later multiplied with 2.
C        WRITE(BUFFER,242) NZL
C 242    FORMAT(1X,'PREPRO: Nonzero estimate for Cholesky ',I10)
C        CALL MYWRT(IOLOG,BUFFER)
      ENDIF
C
C     Print the current date, time and elapsed time.
      WRITE(BUFFER,241)
  241 FORMAT(1X,'PREPRO: Minimum degree ordering done.')
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
C
C     CALL MYTIME(1,IOLOG)
C     CALL MYTIME(1,0)
C
C *** DEBUGGING
C     WRITE(BUFFER,251)
C 251 FORMAT(1X,'PREPRO: Permutations after MDO')
C     CALL MYWRT(IOLOG,BUFFER)
C     DO 253 I=1,M
C        WRITE(BUFFER,252) I,PERM(I),INVP(I)
C 252    FORMAT(1X,'PREPRO:  row=',I6,'  perm=',I6,'  invp=',I6)
C        CALL MYWRT(IOLOG,BUFFER)
C 253 CONTINUE
C
C
C
C     Reorder the rows of the  LP constraint matrix with
C     the permutation resulting from the minimum degree heuristic.
C
      CALL REORDA(MAXM,MAXN,MAXNZA,M,N,
     X IWORK(IMAP(1)),IWORK(IMAP(2)),
     X IWORK(IMAP(3)),IWORK(IMAP(4)),IWORK(IMAP(5)),IWORK(IMAP(6)),
     X PERM,INVP,IMTMP1,IMTMP2,RMTMP1,
     X RWNAME,STAROW,RWSTAT,RANGES,RWORK(RMAP(3)),IOLOG)
C
C     Reorder  P, Q and MSPLIT arrays.
C
      CALL REORDV(MAXM,M,
     X PERM,INVP,P,RMTMP1,IOLOG)
      CALL REORDV(MAXM,M,
     X PERM,INVP,Q,RMTMP1,IOLOG)
      CALL REORDI(MAXM,M,
     X PERM,INVP,MSPLIT,IMTMP1(1),IOLOG)
C
C
      IF(ICALL.GE.1) THEN
         NZL=2*NZL
         IF(NZL.LT.NZAAT) NZL=NZAAT
         IF(NZL.LT.2*MAXNZA) NZL=2*MAXNZA
      ENDIF
      IF(ICALL.EQ.2) GO TO 1000
C
C
C     Check if there is enough room for Cholesky factor.
      IF(NZL.GT.MAXNZL) GO TO 9000
C
C
C     Perform the symbolic factorization.
  400 CONTINUE
C
      CALL SYMFCT(LLINKS,IROW,
     X LCLPTS,LRWNBS,MAXNZL,MAXM,MAXN,MAXNZA,M,
     X HEADER,LINKFD,LINKBK,IMTMP1,IMTMP2,STAVAR,
     X IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(3)),
     X IWORK(IMAP(4)),IWORK(IMAP(5)),IWORK(IMAP(6)),IOLOG)
C
C     Check if the symbolic factorization completed successfully.
C     Stop in pure FORTRAN version of HOPDM.
      IF(RTCD.EQ.0) THEN
         NZL=NZCHL
         IF(NZL.LT.2*MAXNZA) NZL=2*MAXNZA
         IF(ICALL.GE.1) GO TO 1000
         CALL MYSTOP(7)
      ENDIF
      IF(NZL.LT.2*MAXNZA) NZL=2*MAXNZA
C
C     Permute nonzero elements in columns of A to ensure
C     their increasing order.
C     NOTE that LLINKS array is used here as a work space.
C     There must be  MAXNZL .GE. 2 * MAXNZA to avoid crush.
      IF(MAXNZL.LT.2*MAXNZA) GO TO 9100
C
C
      CALL DTSRTA(MAXM,MAXN,MAXNZA,M,N,
     X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(6)),
     X IWORK(IMAP(3)),IWORK(IMAP(4)),IWORK(IMAP(5)),
     X LLINKS(1),INTMP1,STAVAR,IOLOG)
C
C
C
C
 1000 CONTINUE
      RETURN
C
C
C     Here to write error message.
 9000 WRITE(BUFFER,9001) NZL
 9001 FORMAT(1X,'PREPRO ERROR: Cholesky factor overflow ',I10)
      CALL ERRWRT(IOLOG,BUFFER)
      WRITE(BUFFER,9002) MAXNZL
 9002 FORMAT(1X,'        space was provided for only    ',I10,
     X          ' nonzeros.')
      CALL ERRWRT(IOLOG,BUFFER)
      CALL MYSTOP(7)
C
 9100 WRITE(BUFFER,9101) 2*MAXNZA
 9101 FORMAT(1X,'PREPRO ERROR: MAXNZL has to be at least ',I10)
      CALL ERRWRT(IOLOG,BUFFER)
      CALL MYSTOP(7)
C
C
C
C *** LAST CARD OF (PREPRO) ***
      END
